'$sim
$tiny
$noramclear
$regfile = "attiny12.dat"
$crystal = 1200000
$hwstack = 2
$swstack = 2
$framesize = 0

Config Timer0 = Timer , Prescale = 1024       '1,2MHz/1024 *256(8bit)=218ms
Config Portb = &B01111

Portb = &B10000               'PB.0=0 => grzanie zaczone

Enable Interrupts
Enable Timer0
On Timer0 Przerwanie
Start Timer0

$asm
.equ Gas_in = 4
.equ Buzzer = 1
.equ Heat = 0
.equ Alarm2 = 2
.equ Alarm1 = 3
'30s / 218ms = 137
.equ 30s = 137
'20min / 218ms = 5505 => R13 = 21 ; Patrz Procedura Licz
.equ 20min = 21

ldi r16,0
clr r12                 ;r12 = time_low
clr r13                 ;r13 = time_high

Licz30s:
   mov r16, r12         ;kopiuj zawarto time_low do r16
   cpi r16, 30s         ;porwnaj r16 ze sta 30s i
   breq heat_off        ;jeli jest rwna to skocz do heat_off
   rjmp licz30s         ;jeli nie to skocz do licz30s

Heat_off:
   sbi portb,heat
   clr r12              ;przed ponownym odmierzeniem czasu wyzeruj liczniki
   clr r13
   breq standby

Standby:
   mov r16, r13
   cpi r16, 20min
   breq  Heat_on
   rjmp standby

Heat_on:
   cBI PORTB, heat
   clr r12              ;przed ponownym odmierzeniem czasu wyzeruj liczniki
   clr r13
   breq Licz30s

$end Asm

Przerwanie:
$asm
   inc r12
   mov r16,r12          ;kopiuje zawartosc r12 do r16- cpi dziaa tylko na r16-r32
   cpi r16, 0
   brne alarm_tst
   inc r13

Alarm_tst:
   in r16,pinb
   andi r16,16
   cpi r16,16
   breq alarm_off
   cpi r16,0
   breq alarm_on

Alarm_off:
   cbi portb, alarm1
   cbi portb, buzzer
   breq nopp

Alarm_on:
   sbi portb, alarm1     ;zacz wyjcie alarmowe nr 1
   sbrc r12 ,0
   sbi portb,buzzer
   sbrs r12, 0
   cbi portb, buzzer

Nopp:
   nop

$end Asm
Return
End